import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import MoleculeField from '@s-ui/react-molecule-field';
import MoleculeSelect, { moleculeSelectStates } from '@s-ui/react-molecule-select';

var hasErrors = function hasErrors(_ref) {
  var successText = _ref.successText,
      errorText = _ref.errorText;
  if (errorText) return true;
  if (successText) return false;
};

var getState = function getState(_ref2) {
  var successText = _ref2.successText,
      errorState = _ref2.errorState,
      alertText = _ref2.alertText;
  if (successText) return moleculeSelectStates.SUCCESS;
  if (errorState) return moleculeSelectStates.ERROR;
  if (alertText) return moleculeSelectStates.ALERT;
};

var MoleculeSelectField = function MoleculeSelectField(_ref3) {
  var children = _ref3.children,
      errorText = _ref3.errorText,
      helpText = _ref3.helpText,
      id = _ref3.id,
      inline = _ref3.inline,
      label = _ref3.label,
      successText = _ref3.successText,
      alertText = _ref3.alertText,
      handleChange = _ref3.onChange,
      props = _objectWithoutPropertiesLoose(_ref3, ["children", "errorText", "helpText", "id", "inline", "label", "successText", "alertText", "onChange"]);

  var refSelect = useRef();

  var handleClick = function handleClick() {
    var domSelect = refSelect.current;
    if (domSelect) domSelect.focus();
  };

  var errorState = hasErrors({
    successText: successText,
    errorText: errorText
  });
  var selectState = getState({
    successText: successText,
    errorState: errorState,
    alertText: alertText
  });
  return /*#__PURE__*/_jsx(MoleculeField, {
    errorText: errorText,
    helpText: helpText,
    inline: inline,
    label: label,
    name: id,
    onChange: handleChange,
    onClickLabel: handleClick,
    successText: successText,
    alertText: alertText,
    children: /*#__PURE__*/_jsx(MoleculeSelect, _extends({
      errorState: errorState,
      refMoleculeSelect: refSelect,
      state: selectState,
      id: id
    }, props, {
      children: children
    }))
  });
};

MoleculeSelectField.displayName = 'MoleculeSelectField';
export default MoleculeSelectField;